'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _shallowEqual = require('./shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _graphqlRequest = require('graphql-request');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GraqhqlRenderer = function (_React$Component) {
  _inherits(GraqhqlRenderer, _React$Component);

  function GraqhqlRenderer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GraqhqlRenderer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GraqhqlRenderer.__proto__ || Object.getPrototypeOf(GraqhqlRenderer)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isFetching: true,
      data: null,
      error: null
    }, _this.dispatch = function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;

      _this.setState({ isFetching: true, error: null });

      var headers = typeof props.headers === 'function' ? props.headers() : props.headers;

      var client = new _graphqlRequest.GraphQLClient(props.endpoint, {
        headers: headers
      });

      return client.request(props.query, props.variables).then(function (data) {
        if (_this.willUnmount) {
          return;
        }
        _this.setState({
          isFetching: false,
          data: data
        });
      }).catch(function (error) {
        if (_this.willUnmount) {
          return;
        }
        if (props.onError) {
          props.onError(error);
        }
        _this.setState({
          isFetching: false,
          error: error
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GraqhqlRenderer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.dispatch();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if ((0, _shallowEqual2.default)(nextProps.query, this.props.query) && (0, _shallowEqual2.default)(nextProps.variables, this.props.variables) && (0, _shallowEqual2.default)(nextProps.endpoint, this.props.endpoint)) {
        return;
      }
      this.dispatch(nextProps);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.willUnmount = true;
    }
  }, {
    key: 'render',
    value: function render() {
      if (!this.props.children) {
        return null;
      }
      return this.props.children({
        isFetching: this.state.isFetching,
        data: this.state.data,
        error: this.state.error,
        dispatch: this.dispatch
      }) || null;
    }
  }]);

  return GraqhqlRenderer;
}(_react2.default.Component);

GraqhqlRenderer.propTypes = {
  endpoint: _propTypes2.default.string.isRequired,
  query: _propTypes2.default.string.isRequired,
  variables: _propTypes2.default.any,
  headers: _propTypes2.default.any,
  children: _propTypes2.default.func,
  onError: _propTypes2.default.func
};
GraqhqlRenderer.defaultProps = {
  variables: {}
};
exports.default = GraqhqlRenderer;